# IMediumAttachment Interface Reference

The IMediumAttachment interface represents the attachment of a storage medium to a virtual machine. More...

List of all members.

## Public Attributes
readonly attribute IMedium | medium
| Medium object associated with this attachment; it can be `null` for removable devices.
readonly attribute wstring | controller
| Name of the storage controller of this attachment; this refers to one of the controllers in IMachine::storageControllers by name.
readonly attribute long | port
| Port number of this attachment.
readonly attribute long | device
| Device slot number of this attachment.
readonly attribute DeviceType | type
| Device type of this attachment.
readonly attribute boolean | passthrough
| Pass I/O requests through to a device on the host.

## Detailed Description

The IMediumAttachment interface represents the attachment of a storage medium to a virtual machine.

Each machine contains an array of its medium attachments in IMachine::mediumAttachments.

Each medium attachment specifies a storage controller as well as a port and device number. Fixed media (hard disks) will always also specify an instance of IMedium in medium, referring to the hard disk medium. For removeable media, the IMedia instance is optional; it can be `null` if no media is mounted (see IMachine::mountMedium).

Interface ID:
  `{E58EB3EB-8627-428B-BDF8-34487C848DE5}`

## Member Data Documentation

readonly attribute IMedium IMediumAttachment::medium

Medium object associated with this attachment; it can be `null` for removable devices.

readonly attribute wstring IMediumAttachment::controller

Name of the storage controller of this attachment; this refers to one of the controllers in IMachine::storageControllers by name.

readonly attribute long IMediumAttachment::port

Port number of this attachment.

See IMachine::attachDevice for the meaning of this value for the different controller types.

readonly attribute long IMediumAttachment::device

Device slot number of this attachment.

See IMachine::attachDevice for the meaning of this value for the different controller types.

readonly attribute DeviceType IMediumAttachment::type

Device type of this attachment.

readonly attribute boolean IMediumAttachment::passthrough

Pass I/O requests through to a device on the host.